HDU1087 Super Jumping! Jumping! Jumping!

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output

4
10
3

Author

lcy

求单调递增子序列中和最大的一个。
我的思路是:
两层循环,层层向前推: dp[i]=max(dp[i],dp[i]+dp[j])。
比如这组数据 6 4 9 6 8 5 10;一共有六个数,层层循环,就会发现这种情况:
HDU1087 Super Jumping! Jumping! Jumping!_第1张图片
试了好多次,好像只要这组数据过了,这道题就过了。
以下是AC的代码:

#include<stdio.h>
#include<string>
#define maxn 100000
using namespace std;
int main()
{
    int s[maxn],dp[maxn],T;
    while(scanf("%d",&T)&&T)
    {
        int max=0;
        for(int i=0; i<T; i++)
        {
            scanf("%d",&s[i]);
            dp[i]=s[i];
            for(int j= i-1; j>=0; j--)
                if(s[i]>s[j])//如果后一个数大于前一个数
                {
                    if(dp[i]<dp[j]+s[i])//如果后一个数小于它本身加上前一个比他小的数所在位置的dp[i]的和。
                        dp[i]=dp[j]+s[i];
                }
            if(max<dp[i])
                max=dp[i];
        }
        printf("%d\n",max);
    }
    return 0;
}

你可能感兴趣的:(HDU1087 Super Jumping! Jumping! Jumping!)